package com.iRecruit;

import java.util.TimeZone;

import javax.annotation.PostConstruct;
import javax.annotation.Resource;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.SpringApplication;
import org.springframework.boot.autoconfigure.SpringBootApplication;
import org.springframework.boot.autoconfigure.domain.EntityScan;
import org.springframework.boot.builder.SpringApplicationBuilder;
import org.springframework.boot.web.servlet.support.SpringBootServletInitializer;
import org.springframework.cache.annotation.EnableCaching;
import org.springframework.context.annotation.Bean;
import org.springframework.data.domain.AuditorAware;
import org.springframework.data.jpa.convert.threeten.Jsr310JpaConverters;
import org.springframework.data.jpa.repository.config.EnableJpaAuditing;
import org.springframework.scheduling.annotation.EnableScheduling;

import com.iRecruit.audit.SpringSecurityAuditorAware;
import com.iRecruit.constant.DBConfig;
import com.iRecruit.constant.TemplateConfig;

//@EnableAutoConfiguration(exclude = { DataSourceAutoConfiguration.class, MultipartAutoConfiguration.class })
@SpringBootApplication
@EnableCaching
@EnableJpaAuditing(auditorAwareRef = "auditorAware")
public class IRecruitApplication {

	
	@PostConstruct
	void init() {
		TimeZone.setDefault(TimeZone.getTimeZone("UTC"));
	}
	
	@Autowired 
	DBConfig DBConfig;
	
	@Autowired
	TemplateConfig TemplateConfig;
	
	
	@Bean 
    public AuditorAware<String> auditorAware() { 
        return new SpringSecurityAuditorAware();
    }

	/*@Override
    protected SpringApplicationBuilder configure(SpringApplicationBuilder application) {
        return application.sources(IRecruitApplication.class);
    }*/
	
	public static void main(String[] args) {
	
		SpringApplication.run(IRecruitApplication.class, args);
		
	}
	

}
 