package com.iRecruit.config;

import java.util.Date;

import javax.validation.ConstraintViolationException;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.support.DefaultMessageSourceResolvable;
import org.springframework.http.HttpHeaders;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.validation.FieldError;
import org.springframework.validation.ObjectError;
import org.springframework.web.bind.MethodArgumentNotValidException;
import org.springframework.web.bind.annotation.ControllerAdvice;
import org.springframework.web.bind.annotation.ExceptionHandler;
import org.springframework.web.bind.annotation.ModelAttribute;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.context.request.WebRequest;
import org.springframework.web.servlet.mvc.method.annotation.ResponseEntityExceptionHandler;

import com.iRecruit.modules.auth.model.AuditLogs;
import com.iRecruit.modules.auth.payload.AuditLogsDto;
import com.iRecruit.modules.auth.payload.request.ApiResponse;
import com.iRecruit.modules.auth.service.AuditLogsService;
import com.iRecruit.security.UserPrincipal;

import lombok.extern.slf4j.Slf4j;

@Slf4j
@ControllerAdvice
public class APIExceptionHandler extends ResponseEntityExceptionHandler {
	/*
	 * private Object request;
	 * 
	 * @ModelAttribute public void setRequest(@RequestBody Object request) {
	 * this.request = request; }
	 */
    
	@Autowired
	AuditLogsService auditLogsService;
	
    /*@Override
    protected ResponseEntity handleMethodArgumentNotValid(MethodArgumentNotValidException ex, HttpHeaders headers, HttpStatus status, WebRequest request) {
        log.error(ex.getMessage(), ex);
        String error = "";
        for(ObjectError oe :  ex.getBindingResult().getAllErrors()) {
        	DefaultMessageSourceResolvable dmsr = null;
        	for(Object a : oe.getArguments()) {
        		if(a instanceof DefaultMessageSourceResolvable) {
        			dmsr = (DefaultMessageSourceResolvable)a;
        			break;
        		}
        	}
        	if(dmsr != null) {
        		error += dmsr.getDefaultMessage()+" = " + oe.getDefaultMessage()+",";
        	}else {
        		error += oe.getDefaultMessage()+",";
        	}
        	
        }
        FieldError fieldError = ex.getBindingResult().getFieldError();
        ApiResponse responseDTO = new ApiResponse(status.value(), true, error, null);

        String remoteAddr = "";
        if (headers != null) {
            remoteAddr = request.getHeader("X-FORWARDED-FOR");
            if (remoteAddr == null || "".equals(remoteAddr)) {
                remoteAddr = request.getHeader("REMOTE_ADDR");
            }
        }
        UserPrincipal userPrincipal = (UserPrincipal)request.getUserPrincipal();
        log.info(userPrincipal.toString());
        AuditLogs auditLogs = new AuditLogs(null, ex.getBindingResult().getNestedPath(), remoteAddr,
	    		userPrincipal.getDeviceInfo(), userPrincipal.getBrowserInfo(), userPrincipal.getUsername(), userPrincipal.getOS(), 
	    		status.value(), error, 1L, "" , ex.getMessage(),new Date());
	    
	    AuditLogsDto auditLogsDto = new AuditLogsDto(auditLogs);
	    
	    auditLogsService.save(auditLogsDto);
	    
        return ResponseEntity.badRequest().body(responseDTO);
    }*/

    @ExceptionHandler(ConstraintViolationException.class)
    public final ResponseEntity<Object> handleConstraintViolationException(Exception ex, WebRequest request) {
        log.error(ex.getMessage(), ex);

        ApiResponse responseDTO = new ApiResponse(HttpStatus.BAD_REQUEST.value(), true, ex.getMessage(), null);

        return ResponseEntity.badRequest().body(responseDTO);
    }
}
