package com.iRecruit.config;

import java.util.HashMap;

import javax.sql.DataSource;
import org.springframework.jdbc.datasource.lookup.AbstractRoutingDataSource;

public class CommonRoutingDataSource extends AbstractRoutingDataSource {

	@Override
	protected Object determineCurrentLookupKey() {
	    return DataSourceContextHolder.getDataSourceName();
	}
	
	public void initDataSources(final DataSource dataSource1, final DataSource dataSource2,
	        final String defaultDataSourceKey) {
	    final java.util.Map<Object, Object> dataSourceMap = new HashMap<Object, Object>();
	    dataSourceMap.put("iRecruitSchemaDataSource", dataSource1);
	    dataSourceMap.put("NAAFSchemaDataSource", dataSource2);
	    this.setDefaultTargetDataSource(dataSourceMap.get("iRecruitSchemaDataSource"));
	    this.setTargetDataSources(dataSourceMap);
	}

}
