package com.iRecruit.constant;

import java.util.List;

import javax.annotation.PostConstruct;

import org.json.JSONArray;
import org.json.JSONObject;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.iRecruit.modules.auth.model.FycMapping;
import com.iRecruit.modules.auth.model.L1slabsMapping;
import com.iRecruit.modules.auth.model.L2slabsMapping;
import com.iRecruit.modules.auth.model.MDBMapping;
import com.iRecruit.modules.auth.model.MpbMapping;
import com.iRecruit.modules.auth.model.MsaMapping;
import com.iRecruit.modules.auth.model.Templates;
import com.iRecruit.modules.auth.service.FycMappingService;
import com.iRecruit.modules.auth.service.L1slabsMappingService;
import com.iRecruit.modules.auth.service.L2slabsMappingService;
import com.iRecruit.modules.auth.service.MDBMappingService;
import com.iRecruit.modules.auth.service.MpbMappingService;
import com.iRecruit.modules.auth.service.MsaMappingService;
import com.iRecruit.modules.auth.service.TemplatesService;

@Service
public class LeaderCalcConfig {

	private static JSONObject LeaderMpbMappingJSon;

	private static JSONArray jarray;

	private static JSONArray jarraympbconfig;
	private static JSONArray jarrayfycconfig;
	private static JSONArray jarrayl1slabsconfig;
	private static JSONArray jarrayl2slabsconfig;
	
	private static JSONObject LeaderFycMapping;
	private static JSONObject LeaderL1SlabsMapping;
	private static JSONObject LeaderL2SlabsMapping;
	private static JSONArray jarrayfyc;
	
	private static JSONArray jarrayMsa;
	
	private static JSONObject LeaderMdbMapping;
	
	private static JSONObject LeaderMsaMapping;
	
	
	private static JSONArray jarrayl1slabs;
	private static JSONArray jarrayMdbslabs;
	
	private static JSONArray jarrayl2slabs;
	private static  JSONArray jarrayMDBconfig;
	private static final Logger LOG = LoggerFactory.getLogger(LeaderCalcConfig.class);

	@Autowired
	MpbMappingService mpbMappingService;
	@Autowired
	FycMappingService fycMappingService;
	@Autowired
	L1slabsMappingService l1slabsMappingService;
	@Autowired
	L2slabsMappingService l2slabsMappingService;
	@Autowired
	MDBMappingService mdbMappingService;
	
	@Autowired
	MsaMappingService msaMappingService;

	@PostConstruct
	public void init() {
		refreshConfig();
	}

	public void refreshConfig() {

		List<MpbMapping> templatesmpb = mpbMappingService.findAll();
		List<FycMapping> templatesfyc = fycMappingService.findAll();
		List<L1slabsMapping> templatesl1slabs = l1slabsMappingService.findAll();
		List<L2slabsMapping> templatesl2slabs = l2slabsMappingService.findAll();
		List<MDBMapping> templatesmdb = mdbMappingService.findAll();
		List<MsaMapping> templatesmsa = msaMappingService.findAll();

		LeaderMpbMappingJSon = new JSONObject();
		LeaderFycMapping = new JSONObject();
		LeaderL1SlabsMapping = new JSONObject();
		LeaderL2SlabsMapping = new JSONObject();
		 LeaderMdbMapping = new JSONObject();
		 LeaderMsaMapping = new JSONObject();

		for (MpbMapping mpbMapping : templatesmpb) {

			jarray = new JSONArray(templatesmpb);
		}
		
		for (FycMapping fycMapping : templatesfyc) {

			jarrayfyc = new JSONArray(templatesfyc);
		}
		
		for (L1slabsMapping l1slabsMapping : templatesl1slabs) {

			jarrayl1slabs = new JSONArray(templatesl1slabs);
		}
		for (L2slabsMapping l2slabsMapping : templatesl2slabs) {

			jarrayl2slabs = new JSONArray(templatesl2slabs);
		}
		
		for (MDBMapping mdbMapping : templatesmdb) {

			 jarrayMdbslabs = new JSONArray(templatesmdb);
		}
		
		for (MsaMapping msaMapping : templatesmsa) {

			 jarrayMsa = new JSONArray(templatesmsa);
		}
		

		System.out.println("jarrayMsa");
		System.out.println(jarrayMsa);
		
		LeaderMpbMappingJSon.put("LeaderMpbMapping", jarray);
		LeaderFycMapping.put("LeaderFycMapping", jarrayfyc);
		LeaderL1SlabsMapping.put("LeaderL1SlabsMapping", jarrayl1slabs);
		LeaderL2SlabsMapping.put("LeaderL2SlabsMapping", jarrayl2slabs);
		
		LeaderMdbMapping.put("MPBMapping", jarrayMdbslabs);
		
	
		
	 
		 jarraympbconfig = new JSONArray();
		 jarrayfycconfig = new JSONArray();
		 jarrayl1slabsconfig = new JSONArray();
		 jarrayl2slabsconfig = new JSONArray();
		 jarrayMDBconfig = new JSONArray();
		
		jarraympbconfig = LeaderMpbMappingJSon.getJSONArray("LeaderMpbMapping");
		jarrayfycconfig = LeaderFycMapping.getJSONArray("LeaderFycMapping");
		jarrayl1slabsconfig = LeaderL1SlabsMapping.getJSONArray("LeaderL1SlabsMapping");
		jarrayl2slabsconfig = LeaderL2SlabsMapping.getJSONArray("LeaderL2SlabsMapping");
		jarrayMDBconfig = LeaderMdbMapping.getJSONArray("MPBMapping");
		
	System.out.println(jarraympbconfig);
	System.out.println(jarrayfycconfig);
	System.out.println(jarrayl1slabsconfig);
	System.out.println(jarrayMDBconfig);
	}

	public JSONArray getValue(String key) {
		if (key.equalsIgnoreCase("mpb")) {
			return jarraympbconfig;
		} else if (key.equalsIgnoreCase("fyc")) {
			return jarrayfycconfig;
		} 
		else if (key.equalsIgnoreCase("l1slabs")) {
			return jarrayl1slabsconfig;
		}
		else if (key.equalsIgnoreCase("l2slabs")) {
			return jarrayl2slabsconfig;
		}
		else if (key.equalsIgnoreCase("mdb")) {
			return jarrayMDBconfig;
		}
		else if (key.equalsIgnoreCase("msa")) {
			return jarrayMsa;
		}else {
			return null;
		}
	}

}
