package com.iRecruit.modules.auth.controller;

import javax.validation.Valid;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.dao.DataIntegrityViolationException;
import org.springframework.data.domain.PageRequest;
import org.springframework.data.domain.Pageable;
import org.springframework.data.domain.Sort;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.PutMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import com.iRecruit.annotation.AuditLogs;
import com.iRecruit.constant.LeaderCalcConfig;
import com.iRecruit.constant.StatusCode;
import com.iRecruit.exception.ResourceNotFoundException;
import com.iRecruit.modules.auth.model.L1slabsMapping;
import com.iRecruit.modules.auth.model.L2slabsMapping;
import com.iRecruit.modules.auth.model.MDBMapping;
import com.iRecruit.modules.auth.model.MpbMapping;
import com.iRecruit.modules.auth.payload.L1slabsDto;
import com.iRecruit.modules.auth.payload.L2slabsDto;
import com.iRecruit.modules.auth.payload.MDBDto;
import com.iRecruit.modules.auth.payload.mpbDto;
import com.iRecruit.modules.auth.payload.request.ApiResponse;

import com.iRecruit.modules.auth.service.MDBMappingService;

import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;

@RestController 
@RequestMapping("/api/v1")
@Api(description = "MDB maping management API")

public class MDBMappingController {

	
	@Autowired
	  MDBMappingService mdbMappingService;
	
	
	LeaderCalcConfig LeaderCalcConfig;
    @PostMapping("/mdbmapping/get")
    @ApiOperation("Get all mdb mapping list")
    @AuditLogs(isRequest = true, isResponse = true,service="Get mdb")
    
  //Neel – 20-Apr-2020 – Tata - mdb mapping – Added function for fetch all data of mdb mapping  table
    public ResponseEntity<?> getAllMDBMappings( ){
    	return new ResponseEntity(new ApiResponse(HttpStatus.OK.value(), true, "MDB List", mdbMappingService.findAll().stream().map(MDBMapping -> new MDBDto(MDBMapping))), HttpStatus.OK);
    }
    
    @PostMapping("/mdbmapping/create")
    @ApiOperation("Create mdbmapping")
    @AuditLogs(isRequest = true, isResponse = true,service="Create mdbmapping")
    //Neel – 20-Apr-2020 – Tata - mdb mapping – Added function for storing all data of mdb mapping  table
    public ResponseEntity<?> createmdbsmapping(@RequestBody MDBDto mdbmapping) {
    	System.out.println("in mdb contrroler");
    	System.out.println("in mdbmapping");
    	MDBMapping mdb = null;
    	try {
    		mdb =  mdbMappingService.save(mdbmapping,true);

    	}catch(ResourceNotFoundException e) {
    		e.printStackTrace();
    		return new ResponseEntity(new ApiResponse(StatusCode.RESOURCE_NOT_FOUND, true, "mdbmapping Not found", mdb.getId()), HttpStatus.NOT_FOUND);
    	}catch(Exception e) {
    		e.printStackTrace();
    		return new ResponseEntity(new ApiResponse(StatusCode.UNEXPECTED_ERROR, true, "mdbmapping creation failed", mdb.getId()), HttpStatus.BAD_REQUEST);
    	}
    	return new ResponseEntity(new ApiResponse(HttpStatus.OK.value(), true, "l2mapping added successfully", new MDBDto(mdb)), HttpStatus.OK);
    	//return new ResponseEntity(new ApiResponse(StatusCode.RESOURCE_EXIST, true, "USER_Already_Exist", null), HttpStatus.NOT_FOUND);
    }
    
    @PostMapping("/mdbmapping/update")
    @ApiOperation("update mdbmapping")
    @AuditLogs(isRequest = true, isResponse = true,service="Create mdbmapping")
    public ResponseEntity<?> updatemdbsmapping(@RequestBody MDBDto mdbmapping) {
    	System.out.println("in mdb contrroler");
    	System.out.println("in mdbmapping");
    	MDBMapping mdb = null;
    	try {
    		mdb =  mdbMappingService.save(mdbmapping,false);

    	}catch(ResourceNotFoundException e) {
    		e.printStackTrace();
    		return new ResponseEntity(new ApiResponse(StatusCode.RESOURCE_NOT_FOUND, true, "mdbmapping Not found", mdb.getId()), HttpStatus.NOT_FOUND);
    	}catch(Exception e) {
    		e.printStackTrace();
    		return new ResponseEntity(new ApiResponse(StatusCode.UNEXPECTED_ERROR, true, "mdbmapping updation failed", mdb.getId()), HttpStatus.BAD_REQUEST);
    	}
    	return new ResponseEntity(new ApiResponse(HttpStatus.OK.value(), true, "l2mapping added successfully", new MDBDto(mdb)), HttpStatus.OK);
    	//return new ResponseEntity(new ApiResponse(StatusCode.RESOURCE_EXIST, true, "USER_Already_Exist", null), HttpStatus.NOT_FOUND);
    }
}
