package com.iRecruit.modules.auth.controller;

import java.util.HashMap;
import java.util.Map;

import javax.validation.Valid;

import org.json.JSONObject;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.dao.DataIntegrityViolationException;
import org.springframework.data.domain.PageRequest;
import org.springframework.data.domain.Pageable;
import org.springframework.data.domain.Sort;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.PutMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import com.fasterxml.jackson.core.JsonParser;
import com.fasterxml.jackson.core.JsonProcessingException;
import com.fasterxml.jackson.databind.ObjectMapper;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import com.iRecruit.annotation.AuditLogs;
import com.iRecruit.constant.LeaderCalcConfig;
import com.iRecruit.constant.StatusCode;
import com.iRecruit.exception.ResourceNotFoundException;
import com.iRecruit.modules.auth.model.L1slabsMapping;
import com.iRecruit.modules.auth.model.MpbMapping;
import com.iRecruit.modules.auth.payload.L1slabsDto;
import com.iRecruit.modules.auth.payload.mpbDto;
import com.iRecruit.modules.auth.payload.request.ApiResponse;
import com.iRecruit.modules.auth.service.L1slabsMappingService;
import com.iRecruit.modules.auth.service.LeaderCalcService;
import com.iRecruit.modules.auth.service.NGPACalcService;

import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;

@RestController 
@RequestMapping("/api/v1")
@Api(description = "NGPA Calc API")

public class NGPACalc {
	
	@Autowired
	NGPACalcService nGPACalcService;
	
	LeaderCalcConfig LeaderCalcConfig;
	 @PostMapping(value = "/ngpaCalculation", headers = "Accept=application/json")
	    @ApiOperation("Create ngpacalc")
	 @AuditLogs(isRequest = true, isResponse = true,service="Ngpa service")
	 @JsonSerialize
	 public ResponseEntity<?> CalculateNGPA(@RequestBody Map<String, Object> lookupRequestObject) throws JsonProcessingException {
	    	System.out.println("in ngpa contrroler");
	    	
	    	 ObjectMapper mapper = new ObjectMapper();
	    	 
	    	 String data = mapper.writeValueAsString(lookupRequestObject);
	    	 JSONObject requestJSON = new JSONObject(data);
	    	 HashMap<String,Object> result  = null;
	    
	    	JSONObject calc = null;
	    	try {
	    		System.out.println("in try");
	    		calc =  nGPACalcService.prepareAllFormula(requestJSON);
	    		System.out.println("after operation calc");
	    		System.out.println(calc);
	    		
	    		
	    		result =new HashMap<String, Object>();
	    		result.put("response", calc);
	    		System.out.println(result);

	    	}catch(ResourceNotFoundException e) {
	    		e.printStackTrace();
	    	//	return new ResponseEntity(new ApiResponse(StatusCode.RESOURCE_NOT_FOUND, true, "fycmapping Not found", fyc.getId()), HttpStatus.NOT_FOUND);
	    	}catch(Exception e) {
	    		e.printStackTrace();
	    		//return new ResponseEntity(new ApiResponse(StatusCode.UNEXPECTED_ERROR, true, "fycmapping creation failed", fyc.getId()), HttpStatus.BAD_REQUEST);
	    	}
	    	
			
			return new ResponseEntity(new ApiResponse(HttpStatus.OK.value(), true, "calculation done successfully", calc.toString()), HttpStatus.OK);
	    	//return new ResponseEntity(new ApiResponse(StatusCode.RESOURCE_EXIST, true, "USER_Already_Exist", null), HttpStatus.NOT_FOUND);
	    }

}
