package com.iRecruit.modules.auth.model;

import static javax.persistence.TemporalType.TIMESTAMP;

import java.util.Date;

import javax.persistence.EntityListeners;
import javax.persistence.MappedSuperclass;
import javax.persistence.Temporal;

import org.springframework.data.annotation.CreatedBy;
import org.springframework.data.annotation.CreatedDate;
import org.springframework.data.annotation.LastModifiedBy;
import org.springframework.data.annotation.LastModifiedDate;
import org.springframework.data.jpa.domain.support.AuditingEntityListener;

import lombok.Getter;
import lombok.Setter;

@SuppressWarnings("hiding")
@Setter
@Getter
@MappedSuperclass
@EntityListeners(AuditingEntityListener.class)
public abstract class Auditable<String> {

    @CreatedBy
    protected String createdUserId;

    @CreatedDate
    @Temporal(TIMESTAMP)
    protected Date createdTs;

    @LastModifiedBy
    protected String updatedUserId;
 
    @LastModifiedDate
    @Temporal(TIMESTAMP)
    protected Date updatedTs;


}
