package com.iRecruit.modules.auth.model;

import java.sql.Timestamp;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.EntityListeners;
import javax.persistence.EnumType;
import javax.persistence.Enumerated;
import javax.persistence.Id;
import javax.persistence.Table;

import org.springframework.data.jpa.domain.support.AuditingEntityListener;

import com.iRecruit.constant.RolesConstant;
import com.iRecruit.constant.Status;

import lombok.Getter;
import lombok.Setter;

@Entity
@Table(name = "naaf_user_detail")
@Setter
@Getter
@EntityListeners(AuditingEntityListener.class)
public class User {
	
	@Id
	@Column(length=10)
	private String id;
	
	@Column(length=11)
    private String userId;
    @Column(length=200)
    private String firstName;
	@Column(length=200)
    private String lastName;
	@Column(length=30)
    private String userRole;
	@Column(length=100)
    private String emailId;
	@Column(length=40)
    private String mobileNo;
	@Column(length=11)
    private String managerUserId;
	@Column(length=11)
    private String adoaId;
	@Column(length=11)
    private String doaId;
	@Column(length=1)
    private String isActive;
	@Column(length=8)
    private Timestamp createDate;
	@Column(length=8)
    private Timestamp modifiedDate;
	@Column(length=11)
    private String level1NtId;
	@Column(length=11)
    private String level5NtId;
	@Column(length=3)
    private String level1DesignationCode;
	@Column(length=5)
    private String branchCode;
	@Column(length=100)
    private String officeName;
	@Column(length=63)
    private String userRole1;
	@Column(length=30)
    private String branchCdLevel1;
	@Column(length=63)
    private String userRole2;
	@Column(length=30)
    private String level2DesignationC0de;
	@Column(length=30)
    private String branchCdLevel2;
	@Column(length=63)
    private String userRole3;
	@Column(length=30)
    private String level3DesignationC0de;
	@Column(length=30)
    private String branchCdLevel3;
	@Column(length=63)
    private String userRole4;
	@Column(length=30)
    private String level4DesignationC0de;
	@Column(length=30)
    private String branchCdLevel4;
	@Column(length=63)
    private String userRole5;
	@Column(length=30)
    private String level5DesignationC0de;
	@Column(length=30)
    private String branchCdLevel5;
	@Column(length=10)
    private String baType;
    private Long baRank;
    
    @Column(length=1)
    private String gender;
    
    @Column(length=20)
    private String dob;
    
    @Column(length=50)
    private String branchName;
    
    @Column(length=20)
    private String middleName;
    
    @Column(length=5)
    private String designation;
    
    @Column(length=10)
    private String pan;
    
    @Column(length=1)
    private String agentStatus;
    
    @Enumerated(EnumType.STRING)
    protected Status status = Status.ACTIVE;
    
    @Enumerated(EnumType.STRING)
    private RolesConstant role = RolesConstant.LEADER; 
    
    private String notificationId; 
    
    private int failedAttemptLogin = 0;
    
    public User(){}
    
    
    // Getters and Setters ... (Omitted for brevity)
}