package com.iRecruit.modules.auth.model;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.EntityListeners;
import javax.persistence.EnumType;
import javax.persistence.Enumerated;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.Table;
import javax.validation.constraints.NotBlank;
import javax.validation.constraints.NotNull;

import org.hibernate.annotations.GenericGenerator;
import org.hibernate.annotations.Parameter;
import org.springframework.data.jpa.domain.support.AuditingEntityListener;

import com.iRecruit.config.IdGenerator;
import com.iRecruit.constant.Status;

import lombok.Getter;
import lombok.Setter;

@Entity
@Table(name = "tbl_userOTP")
@EntityListeners(AuditingEntityListener.class)
@Setter
@Getter
public class UserOTP  extends Auditable<Long>{
	
	@Id 
	@GeneratedValue(strategy = GenerationType.SEQUENCE, generator = "user_otp_seq")
	@GenericGenerator( 
	        name = "user_otp_seq", 
	        strategy = "com.iRecruit.config.IdGenerator", 
	        parameters = {
	            @Parameter(name = IdGenerator.INCREMENT_PARAM, value = "1"),
	            @Parameter(name = IdGenerator.VALUE_PREFIX_PARAMETER, value = "UO"),
	            @Parameter(name = IdGenerator.NUMBER_FORMAT_PARAMETER, value = "%08d")})
	@Column(length=10)
    private String id;

    @NotNull
//    @OneToOne(cascade = CascadeType.ALL,fetch = FetchType.LAZY)
//    @JoinColumn(name = "user_id")
    private String userId;
    
    @NotBlank
    private String  OTP;
   
    @Enumerated(EnumType.STRING)
    protected Status status = Status.INIT;
    public Status getStatus() {
        return status;
    }
    
}

