package com.iRecruit.modules.auth.service.impl;

import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import com.iRecruit.constant.LeaderCalcConfig;
import com.iRecruit.exception.ResourceNotFoundException;
import com.iRecruit.modules.auth.model.L2slabsMapping;
import com.iRecruit.modules.auth.model.MDBMapping;
import com.iRecruit.modules.auth.payload.MDBDto;

import com.iRecruit.modules.auth.repository.MDBRepository;
import com.iRecruit.modules.auth.service.MDBMappingService;

@Service
public class MDBMappingServiceImpl implements MDBMappingService {

	@Autowired
	MDBRepository mdbrepo;
	
	
	@Autowired
	LeaderCalcConfig LeaderCalcConfig;


	@Override
	public List<MDBMapping> findAll() {
		// TODO Auto-generated method stub
		 return mdbrepo.findAll();
	}


	@Override
	public MDBMapping save(MDBDto dto,Boolean isCreate) {
		

		if(!isCreate) {
			mdbrepo.findById(dto.getID()).orElseThrow(()->new ResourceNotFoundException("mdb","key",dto.getID()));
		 }
		MDBMapping mdbmapping = null;
		mdbmapping = new MDBMapping();
		mdbmapping.setId(dto.getID());
		mdbmapping.setMDB(dto.getMDB());
		mdbmapping.setMonthly_ep_144(dto.getMonthly_ep_144());
		mdbmapping.setMonthly_ep_18(dto.getMonthly_ep_18());
		mdbmapping.setMonthly_ep_36(dto.getMonthly_ep_36());
		mdbmapping.setMonthly_ep_72(dto.getMonthly_ep_72());

		return mdbrepo.save(mdbmapping);
	}
}
