// Yashvant Calculation Of NGPA Based On Request From Front End - 4 Apr 2020 
// Exception Handled Using JSONException Feature
package com.iRecruit.modules.auth.service.impl;

import java.util.List;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.google.gson.JsonObject;
import com.iRecruit.constant.LeaderCalcConfig;
import com.iRecruit.constant.TemplateConfig;
import com.iRecruit.exception.ResourceNotFoundException;
import com.iRecruit.modules.auth.controller.LeaderCalc;
import com.iRecruit.modules.auth.service.FycMappingService;
import com.iRecruit.modules.auth.service.LeaderCalcService;
import com.iRecruit.modules.auth.service.NGPACalcService;
import com.iRecruit.constant.LeaderCalcConfig;

@Service

public class NGPACalcSerivceImpl implements NGPACalcService {

	
	@Autowired
	LeaderCalcConfig leaderCalcConfig;
	int i,j,counter;
	double basicDoubleOperation;
	String basicStringOperation;
	JSONObject basicJSONOperation = new JSONObject();
	JSONObject basicJSONOperation1 = new JSONObject();
	String[] basicStringArrayOperation = new String[4];
	
	 double fycPersantage = 25;
	final double rnrPersantageACP = 2.5;
	JSONArray MSA_Value = new JSONArray();
	double[][] mainTable = new double[4][6];
	double[][] appointmentAndConversionTable = new double[4][2];
	double[][] earningsTable = new double[4][4];
	JSONObject Response_JSON = new JSONObject();
	
	public void prepareMainTable(JSONObject requestJSON) throws JSONException {

		basicJSONOperation = new JSONObject();
		basicJSONOperation = requestJSON.getJSONObject("Per_Month").getJSONObject("Year_1");
		mainTable[0][0] = ( ( basicJSONOperation.getString("Validations_Met").equalsIgnoreCase("Yes") ) ? 1 : 0 ); 
		mainTable[0][1] = basicJSONOperation.getDouble("Customer_Appointments");
		mainTable[0][2] = basicJSONOperation.getDouble("Customer_Meetings");
		mainTable[0][3] = basicJSONOperation.getDouble("Conversion_(NOP#)");
		mainTable[0][4] = basicJSONOperation.getDouble("Case_Size_(INR)");
		mainTable[0][5] = mainTable[0][3] * mainTable[0][4];
		
		basicStringOperation = requestJSON.getString("Annual_Year_1_Validations_Met");
		mainTable[1][0] = ( ( basicStringOperation.equalsIgnoreCase("Yes") ) ? 1 : 0 ); 
		mainTable[1][1] = mainTable[0][1] * 12;
		mainTable[1][2] = mainTable[0][2] * 12;
		mainTable[1][3] = mainTable[0][3] * 12;
		mainTable[1][5] = mainTable[0][5] * 12;
		mainTable[1][4] = mainTable[1][5] / mainTable[1][3];
		
		basicJSONOperation = new JSONObject();
		basicJSONOperation = requestJSON.getJSONObject("Per_Month").getJSONObject("Year_2");
		mainTable[2][0] = ( ( basicJSONOperation.getString("Validations_Met").equalsIgnoreCase("Yes") ) ? 1 : 0 ); 
		mainTable[2][1] = basicJSONOperation.getDouble("Customer_Appointments");
		mainTable[2][2] = basicJSONOperation.getDouble("Customer_Meetings");
		mainTable[2][3] = basicJSONOperation.getDouble("Conversion_(NOP#)");
		mainTable[2][4] = basicJSONOperation.getDouble("Case_Size_(INR)");
		mainTable[2][5] = mainTable[2][3] * mainTable[2][4];
		
		basicStringOperation = requestJSON.getString("Annual_Year_2_Validations_Met");
		mainTable[3][0] = ( ( basicStringOperation.equalsIgnoreCase("Yes") ) ? 1 : 0 ); 
		mainTable[3][1] = mainTable[2][1] * 12;
		mainTable[3][2] = mainTable[2][2] * 12;
		mainTable[3][3] = mainTable[2][3] * 12;
		mainTable[3][5] = mainTable[2][5] * 12;
		mainTable[3][4] = mainTable[2][5] / mainTable[2][3];

	}
	
	public void prepareappointmentAndConversionTable(JSONObject requestJSON) {
		
		for(i=0;i<4;i++) {
			appointmentAndConversionTable[i][0] = Math.round( ( mainTable[i][2] / mainTable[i][1] ) * 100 );
			appointmentAndConversionTable[i][1] = Math.round( ( mainTable[i][3] / mainTable[i][2] ) * 100 );
		}
		
	}
	
	public void prepareEarningsTable(JSONObject requestJSON) throws JSONException {
		
		basicJSONOperation = MSA_Value.getJSONObject(0);
		basicStringOperation = requestJSON.getString("FS_Type");
		basicDoubleOperation = basicJSONOperation.getDouble(basicStringOperation);
		fycPersantage = requestJSON.getDouble("Commission_Rate");
		
		for(i=0;i<4;i++) {
			earningsTable[i][0] =  Math.round( ( mainTable[i][5] * fycPersantage ) / 100 );
			if( i == 0 || i == 2 ) {
				earningsTable[i][1] = basicDoubleOperation;
			} else {
				earningsTable[i][1] = earningsTable[i-1][1] * 12;
				earningsTable[i][2] = Math.round( ( mainTable[i][5] * rnrPersantageACP ) / 100 );
				earningsTable[i-1][2] = earningsTable[i][2] / 12;
			}
		}
		
		counter = 0;
		for(i=0;i<4;i++) {
			earningsTable[i][3] = earningsTable[i][counter] + earningsTable[i][counter+1] + earningsTable[i][counter+2];
		}
		
	}
	@Override
	public JSONObject prepareAllFormula(JSONObject requestJSON) throws JSONException {
		
		MSA_Value= leaderCalcConfig.getValue("msa");
		
		prepareMainTable(requestJSON);
		prepareappointmentAndConversionTable(requestJSON);
		prepareEarningsTable(requestJSON);
		
		Response_JSON.put("FS_Type", requestJSON.getString("FS_Type"));
		
		Response_JSON.put("Annual_Year_1_Validations_Met",requestJSON.getString("Annual_Year_1_Validations_Met"));
		Response_JSON.put("Annual_Year_2_Validations_Met",requestJSON.getString("Annual_Year_2_Validations_Met"));
		Response_JSON.put("Commission_Rate",requestJSON.getDouble("Commission_Rate"));
		for( i=0;i<4;i++ ) {
			basicJSONOperation1 = new JSONObject();
			basicJSONOperation1.put("Validations_Met", ( ( mainTable[i][0] == 1  ) ? "Yes" : "No" ));
			basicJSONOperation1.put("Customer_Appointments", mainTable[i][1]);
			basicJSONOperation1.put("Customer_Meetings", mainTable[i][2]);
			basicJSONOperation1.put("Conversion_(NOP#)", mainTable[i][3]);
			basicJSONOperation1.put("Case_Size_(INR)", mainTable[i][4]);
			basicJSONOperation1.put("WNBP_(INR)", mainTable[i][5]);
			basicJSONOperation1.put("Meeting_To_Appointment", appointmentAndConversionTable[i][0]);
			basicJSONOperation1.put("Conversion_To_Meeting", appointmentAndConversionTable[i][1]);
			basicJSONOperation1.put("FYC_@_25%", earningsTable[i][0]);
			basicJSONOperation1.put("Monthly_Allowance", earningsTable[i][1]);
			basicJSONOperation1.put("Quarter_&_Annual_RnR", earningsTable[i][2]);
			basicJSONOperation1.put("Total_Earnings", earningsTable[i][3]);
			basicStringArrayOperation[i] = basicJSONOperation1.toString();
		}
		
		basicJSONOperation1 = new JSONObject();
		basicJSONOperation = new JSONObject(basicStringArrayOperation[0]);
		basicJSONOperation1.put("Year_1", basicJSONOperation);
		basicJSONOperation = new JSONObject(basicStringArrayOperation[2]);
		basicJSONOperation1.put("Year_2", basicJSONOperation);
		Response_JSON.put("Per_Month", basicJSONOperation1 );
		
		basicJSONOperation1 = new JSONObject();
		basicJSONOperation = new JSONObject(basicStringArrayOperation[1]);
		basicJSONOperation1.put("Year_1", basicJSONOperation);
		basicJSONOperation = new JSONObject(basicStringArrayOperation[3]);
		basicJSONOperation1.put("Year_2", basicJSONOperation);
		Response_JSON.put("Annual", basicJSONOperation1 );
		
		basicJSONOperation = new JSONObject();
		basicJSONOperation.put("As_NGPA_Year_1", earningsTable[0][3]);
		basicJSONOperation.put("As_NGPA_Year_2", earningsTable[2][3]);
		basicJSONOperation.put("As_NGPA_Growth", Math.round( ( ( earningsTable[2][3] / earningsTable[0][3] ) - 1 ) * 100 ) );
		Response_JSON.put("Summary of Income",basicJSONOperation);

		return Response_JSON;
			
	}

	
	

}
