package com.iRecruit.modules.auth.service.impl;

import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.iRecruit.constant.TemplateConfig;
import com.iRecruit.exception.ResourceNotFoundException;
import com.iRecruit.modules.auth.model.Templates;
import com.iRecruit.modules.auth.payload.TemplatesDto;
import com.iRecruit.modules.auth.repository.TemplatesRepository;
import com.iRecruit.modules.auth.service.TemplatesService;

@Service
public class TemplatesServiceImpl implements TemplatesService {

	@Autowired
	TemplatesRepository configRepo;
	
	@Autowired
	TemplateConfig templateConfig;
	
	public Templates save(TemplatesDto dto,Boolean isCreate) {
		 Templates configuration = null;
		 if(!isCreate) {
			 configRepo.findByConfig(dto.getKey()).orElseThrow(()->new ResourceNotFoundException("Template","key",dto.getKey()));
		 }else {
			 configuration = new Templates();
			 configuration.setConfig(dto.getKey());
		 }
		 configuration.setValue(dto.getValue());
		 configuration.setType(dto.getType());
		 templateConfig.setValue(dto.getKey(), dto.getValue());
		 return configRepo.save(configuration);
		 
	 }
	 public List<Templates> findAll(){
		 return configRepo.findAll();
	 }
	 public Templates findByKey(String key) {
		 return configRepo.findByConfig(key).orElseThrow(()->new ResourceNotFoundException("Template","key",key));
	 }
	 
}
