package com.iRecruit.security;
import java.util.ArrayList;
import java.util.List;
import java.util.stream.Collectors;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.security.authentication.AuthenticationProvider;
import org.springframework.security.authentication.BadCredentialsException;
import org.springframework.security.authentication.DisabledException;
import org.springframework.security.authentication.UsernamePasswordAuthenticationToken;
import org.springframework.security.core.Authentication;
import org.springframework.security.core.AuthenticationException;
import org.springframework.security.core.authority.SimpleGrantedAuthority;
import org.springframework.security.crypto.password.PasswordEncoder;
import org.springframework.stereotype.Component;

import com.iRecruit.constant.RolesConstant;
import com.iRecruit.constant.Status;
import com.iRecruit.constant.StatusCode;
import com.iRecruit.modules.auth.model.User;
import com.iRecruit.modules.auth.payload.request.LoginRequest;
import com.iRecruit.modules.auth.service.UserService;


@Component
public class AuthProvider implements AuthenticationProvider {

	private static final Logger LOG = LoggerFactory.getLogger(AuthProvider.class);
	
	@Autowired
	UserService userService;
	
	@Autowired
	PasswordEncoder passwordEncoder;
    

	
	
	@Override
	public Authentication authenticate(Authentication authentication) throws AuthenticationException {
		
			String username = authentication.getPrincipal() + "";
		    String password = authentication.getCredentials() + "";
		    
		    LoginRequest loginRequest = new LoginRequest();
		    loginRequest.setUsername(username);
		    loginRequest.setUserId(password);
		    
		    LOG.info("login request for user "+username);
			// LDAP Service Call
		    
		    User user = null;
		    
		    user = new User();
		    
		    //	user = userService.findById(username);
		    	LOG.info("---------"+user);
		    	
		    
		    	
		    	user.setId("1");
		    	user.setBranchCode("abc");
		    	user.setFirstName("xyz");
		    	user.setLastName("abc");
		    	user.setGender("m");
		    	user.setMobileNo("8238284225");
		    	user.setBranchName("abc");
		    	user.setMiddleName("pqr");
		    	user.setEmailId("gosranineel4@gmail.com");
		    	user.setDesignation("PBA");
		    	user.setPan("pan");
		    	user.setAgentStatus("1");
		    	user.setRole(RolesConstant.LEADER);
		    	
		    	userService.save(user);
		    
		    LOG.info("user-----"+user);		    
		    List<String> roles = new ArrayList<String>();
		   roles.add("leader");
		    return new UsernamePasswordAuthenticationToken(UserPrincipal.create(user,(LoginRequest)authentication.getDetails()), password,roles.stream().map(x -> new SimpleGrantedAuthority("ROLE_"+x)).collect(Collectors.toList()));
		
	
	}
	
	@Override
    public boolean supports(Class<?>aClass) {
        return aClass.equals(UsernamePasswordAuthenticationToken.class);
    }

}