package com.iRecruit.security;

import java.util.stream.Collectors;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.security.core.authority.SimpleGrantedAuthority;
import org.springframework.security.core.userdetails.UserDetails;
import org.springframework.security.core.userdetails.UserDetailsService;
import org.springframework.security.core.userdetails.UsernameNotFoundException;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.iRecruit.modules.auth.model.User;
import com.iRecruit.modules.auth.payload.request.LoginRequest;
import com.iRecruit.modules.auth.service.UserService;


@Service
public class CustomUserDetailsService implements UserDetailsService {

	@Autowired
	UserService userService;

	@Override
	@Transactional
	public UserDetails loadUserByUsername(String username) throws UsernameNotFoundException {

		// Let people login with either username

		UserPrincipal principal = null;
		User user = userService.findById(username);
		//principal = UserPrincipal.create(user);
		return principal;
	} 

	@Transactional
	public UserDetails loadUserById(String id,LoginRequest loginRequest) {
		UserPrincipal principal = null;
			User user = userService.findById(id);
			principal = UserPrincipal.create(user,loginRequest);
			
		return principal;
	}

	@Transactional
	public UserDetails loadUserById(UserPrincipal userPrincipal) {
		//userPrincipal.setAuthorities(userPrincipal.getRoleType().stream().map(x -> new SimpleGrantedAuthority("ROLE_"+x)).collect(Collectors.toList()));
		return userPrincipal;
	}


	
	@Transactional
	public UserDetails loadUserById(String id,String roleType) {
		UserPrincipal principal = null;
			User user = userService.findById(id);
			//principal = UserPrincipal.create(user);
			
		return principal;
	}
}