CREATE TABLE `tbl_users` (
  `id` bigint(20) NOT NULL AUTO_INCREMENT,
  `createdBy` bigint(20) DEFAULT NULL,
  `createdDate` datetime DEFAULT NULL,
  `lastModifiedBy` bigint(20) DEFAULT NULL,
  `lastModifiedDate` datetime DEFAULT NULL,
  `status` int(11) DEFAULT NULL,
  `PAN` varchar(10) DEFAULT NULL,
  `email` varchar(255) DEFAULT NULL,
  `fName` varchar(255) DEFAULT NULL,
  `isPrimary` bit(1) NOT NULL,
  `lName` varchar(255) DEFAULT NULL,
  `mName` varchar(255) DEFAULT NULL,
  `mobileNumber` varchar(255) DEFAULT NULL,
  `password` varchar(255) DEFAULT NULL,
  `profilePicture` longtext,
  `relation` varchar(255) DEFAULT NULL,
  `userId` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `UK_gb4f9vy8o2r8y68dt1rx5p0rq` (`userId`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

ALTER TABLE `tbl_users` ADD COLUMN `notificationId` VARCHAR(255) default null;


CREATE TABLE `tbl_roles` (
  `id` bigint(20) NOT NULL AUTO_INCREMENT,
  `createdBy` bigint(20) DEFAULT NULL,
  `createdDate` datetime DEFAULT NULL,
  `lastModifiedBy` bigint(20) DEFAULT NULL,
  `lastModifiedDate` datetime DEFAULT NULL,
  `status` int(11) DEFAULT NULL,
  `name` varchar(60) DEFAULT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `UK_7i2jhp8gaw6a1vjbtwide88vp` (`name`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE `tbl_user_roles` (
  `userId` bigint(20) NOT NULL,
  `roleId` bigint(20) NOT NULL,
  PRIMARY KEY (`userId`,`roleId`),
  KEY `FK425h90jc6vygkqssxb1y10bol` (`roleId`),
  CONSTRAINT `FK2uh8vv81vjsa46xnwvak5msxa` FOREIGN KEY (`userId`) REFERENCES `tbl_users` (`id`),
  CONSTRAINT `FK425h90jc6vygkqssxb1y10bol` FOREIGN KEY (`roleId`) REFERENCES `tbl_roles` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;



CREATE TABLE `tenants` (
  `id` bigint(20) NOT NULL AUTO_INCREMENT,
  `createdBy` bigint(20) DEFAULT NULL,
  `createdDate` datetime DEFAULT NULL,
  `lastModifiedBy` bigint(20) DEFAULT NULL,
  `lastModifiedDate` datetime DEFAULT NULL,
  `status` int(11) DEFAULT NULL,
  `PAN` varchar(10) DEFAULT NULL,
  `address` varchar(255) DEFAULT NULL,
  `city` varchar(255) DEFAULT NULL,
  `citySurveyNumber` varchar(255) DEFAULT NULL,
  `email` varchar(255) DEFAULT NULL,
  `name` varchar(255) DEFAULT NULL,
  `phoneNumber` varchar(255) DEFAULT NULL,
  `pincode` int(11) NOT NULL,
  `profilePicture` longtext,
  `schemaName` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `UK_538lm8mqtttyah8jxliglc2xq` (`PAN`),
  UNIQUE KEY `UK_ribivgliwsaqa0clee1v4k7ol` (`citySurveyNumber`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


CREATE TABLE `tbl_user_tenant` (
  `id` varchar(255) NOT NULL,
  `isDefault` bit(1) NOT NULL,
  `userId` varchar(255) DEFAULT NULL,
  `tenantId` bigint(20) DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `FK8wcahi4unsun2j5c0n5cv0qjh` (`tenantId`),
  CONSTRAINT `FK8wcahi4unsun2j5c0n5cv0qjh` FOREIGN KEY (`tenantId`) REFERENCES `tenants` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE `tbl_group` (
  `id` bigint(20) NOT NULL AUTO_INCREMENT,
  `createdBy` bigint(20) DEFAULT NULL,
  `createdDate` datetime DEFAULT NULL,
  `lastModifiedBy` bigint(20) DEFAULT NULL,
  `lastModifiedDate` datetime DEFAULT NULL,
  `status` int(11) DEFAULT NULL,
  `name` varchar(60) DEFAULT NULL,
  `type` varchar(60) DEFAULT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `UK_gkhqxoqotwe6ka9rnfxx2s35v` (`name`),
  UNIQUE KEY `UK_38jc70cl58nj3ksye1xyhydum` (`type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE `tbl_user_group` (
  `groupId` bigint(20) NOT NULL,
  `userID` bigint(20) NOT NULL,
  PRIMARY KEY (`userID`,`groupId`),
  KEY `FKjb8fefkepb1l3xcrwyokxxjwo` (`groupId`),
  CONSTRAINT `FKd7lu34k7qgfrv3d7sa0dh6vl4` FOREIGN KEY (`userID`) REFERENCES `tbl_users` (`id`),
  CONSTRAINT `FKjb8fefkepb1l3xcrwyokxxjwo` FOREIGN KEY (`groupId`) REFERENCES `tbl_group` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE `tbl_userOTP` (
  `id` bigint(20) NOT NULL AUTO_INCREMENT,
  `createdBy` bigint(20) DEFAULT NULL,
  `createdDate` datetime DEFAULT NULL,
  `lastModifiedBy` bigint(20) DEFAULT NULL,
  `lastModifiedDate` datetime DEFAULT NULL,
  `OTP` varchar(255) DEFAULT NULL,
  `status` int(11) NOT NULL,
  `user` bigint(20) DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `FK2qp5c0sw96io99abxai46qo9q` (`user`),
  CONSTRAINT `FK2qp5c0sw96io99abxai46qo9q` FOREIGN KEY (`user`) REFERENCES `tbl_users` (`id`)
);


INSERT INTO `tbl_users` (`id`,`createdBy`,`createdDate`,`lastModifiedBy`,`lastModifiedDate`,`PAN`,`email`,`fName`,`isPrimary`,`lName`,`mName`,`mobileNumber`,`password`,`profilePicture`,`relation`,`userId`,status) VALUES (1,1,'2019-12-02 00:00:00',1,'2019-12-02 00:00:00','ANBPM2750K','it2005nn@gmail.com','nirav',1,'modi','narendrakumar','9033882640','$2a$10$KiLXrDn/BmxnYPogKWM03.OQ.t8nnwfPGlKrEueXQ5xkXgKa1vLVu',null,null,'9033882640',1);
INSERT INTO `tbl_user_tenant` VALUES ('1',0,'9033882640',NULL);
INSERT INTO `tbl_roles` VALUES (1,1,'2019-12-03 00:00:00',1,'2019-12-03 00:00:00',1,'Admin'),(2,1,'2019-12-03 00:00:00',1,'2019-12-03 00:00:00',1,'User');
INSERT INTO `tbl_user_roles` VALUES (1,1),(1,2);


